package cz.cvut.kbss.reporting.model;

import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import java.time.LocalDateTime;

@Getter
@Setter
@Entity
@NamedQueries({@NamedQuery(name = "Tag.findByName", query = "SELECT t FROM Tag t WHERE t.name = :name")})
public class Tag extends AbstractEntity {

    @Basic(optional = false)
    @Column(nullable = false, length = 20)
    private String name;

    @Basic(optional = false)
    @Column(nullable = false)
    @Temporal(TemporalType.TIMESTAMP)
    private LocalDateTime created;

    @JoinColumn(nullable = false, name = "AUTHOR_ID")
    @ManyToOne(optional = false, fetch = FetchType.EAGER)
    private Person author;

    @Override
    public String toString() {
        return name + " (" + created + ")";
    }
}
